/*
deletes.c Version 0.1.0  Btree count index node deletes
Copyright (C) 2003  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

/* Usage: deletes filename */

#include <bthash.h>

void putstx(char *pgm)
   {
   fprintf(stderr,"Usage %s filename\n", pgm);
   exit(1);
   } /* putstx */

int main(int argc, char **argv)
   {
   int opnerr;
   int blocks;
   int count;
   int leaf;
   int nonleaf;
   int active;
   int deletes;
   int indxrcd;
   int leafrcd;
   double pernode;
   btreefmt *bthdr;
   char dbname[256];
   if (argc != 2) putstx(*argv);
   strcpy(dbname,*(argv+1));

   bthdr = (btreefmt *) btopen(dbname,READ,&opnerr);
   if (bthdr == NULL)
      {
      fprintf(stderr,"deletes: btopen "
	 "error %d\n", opnerr);
      exit(1);
      } /* open err */
   /* process starts here */

   btdlets(bthdr,&blocks,&count,
      &leaf,&nonleaf,&active,&deletes,
      &indxrcd,&leafrcd);
   pernode = (double) count / (double) blocks;
   printf("deletes: blocks %d records %d "
      "pernode %.1f, %s\n",
      blocks, count, pernode, dbname);
   printf("deletes: leaf %d nonleaf %d "
      "active %d deletes %d index %d leaf %d\n",
      leaf, nonleaf, active, deletes,
      indxrcd, leafrcd);
   printf("deletes: active records %d depth %d\n",
      count - deletes, btdepth(bthdr));

   /**********************************************************/
   btclose(bthdr);
   return(0);
   } /* main */
